package com.lutao.tcp.server.tcptest;

import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import io.netty.channel.Channel;
import io.netty.channel.ChannelInitializer;
import io.netty.handler.codec.DelimiterBasedFrameDecoder;
import io.netty.handler.codec.Delimiters;
import io.netty.handler.codec.LengthFieldBasedFrameDecoder;
import io.netty.handler.codec.string.StringDecoder;
import io.netty.handler.codec.string.StringEncoder;
import io.netty.util.CharsetUtil;

/**
 * 通道初始化
 */
public class BootNettyChannelInitializer<SocketChannel> extends ChannelInitializer<Channel> {

    @Override
    protected void initChannel(Channel ch) throws Exception {

        ByteBuf delimiter = Unpooled.copiedBuffer("\r\n".getBytes(CharsetUtil.UTF_8));

        // 添加DelimiterBasedFrameDecoder
        ch.pipeline().addLast("framer", new DelimiterBasedFrameDecoder(8388608, delimiter));


        //添加编解码，此处代码为解析tcp传过来的参数，为UTF-8格式，可以自定义解码格式
        // ChannelOutboundHandler，依照逆序执行
        ch.pipeline().addLast("encoder", new StringEncoder(CharsetUtil.UTF_8));

        // 属于ChannelInboundHandler，依照顺序执行
        ch.pipeline().addLast("decoder", new StringDecoder(CharsetUtil.UTF_8));


        //ch.pipeline().addLast("framer", new Custom());

        /**
         * 自定义ChannelInboundHandlerAdapter
         */
        ch.pipeline().addLast(new BootNettyChannelInboundHandlerAdapter());

    }

}
